diff --git a/java/code/src/com/redhat/rhn/domain/action/ActionFactory.java b/java/code/src/com/redhat/rhn/domain/action/ActionFactory.java
index c52edd76b23..bd5e1ef3d28 100644
--- a/java/code/src/com/redhat/rhn/domain/action/ActionFactory.java
+++ b/java/code/src/com/redhat/rhn/domain/action/ActionFactory.java
@@ -1024,6 +1024,12 @@ public static void rejectScheduledActions(List<Long> actionsId, String rejection
      * @return true if the action was stopped due to byos servers within it, false otherwise
      */
     public static boolean rejectScheduleActionIfByos(Action action) {
+        if (action.getActionType().equals(ActionFactory.TYPE_HARDWARE_REFRESH_LIST)) {
+            // Hardware refresh detect PAYG/BYOS type and refresh it. This should be possible also
+            // for BYOS systems in case the former detection failed. On error PAYG is set to false,
+            // and we need a way to repeat the detection.
+            return false;
+        }
         List<MinionSummary> byosMinions = MinionServerFactory.findByosServers(action);
         if (CollectionUtils.isNotEmpty(byosMinions)) {
             log.error("To manage BYOS or DC servers from SUSE Manager PAYG, SCC credentials must be " +
diff --git a/java/code/src/com/suse/manager/reactor/hardware/HardwareMapper.java b/java/code/src/com/suse/manager/reactor/hardware/HardwareMapper.java
index 9bf1cd09609..437d64ee8f5 100644
--- a/java/code/src/com/suse/manager/reactor/hardware/HardwareMapper.java
+++ b/java/code/src/com/suse/manager/reactor/hardware/HardwareMapper.java
@@ -553,13 +553,6 @@ else if (!vinst.getHostSystem().getId().equals(zhost.getId())) {
         }
     }
 
-    /**
-     * Map PAYG information for the server to the database.
-     */
-    public void mapPaygInfo() {
-        server.setPayg(grains.getOptionalAsBoolean("is_payg_instance").orElse(false));
-    }
-
     /**
      * Get the memory amount to set. Most of the times we don't want to update it since a better value comes from
      * the virtual host, but for foreign hosts and systems with no memory set, take the value seen from the guest OS:
diff --git a/java/code/src/com/suse/manager/reactor/messaging/RegisterMinionEventMessageAction.java b/java/code/src/com/suse/manager/reactor/messaging/RegisterMinionEventMessageAction.java
index b363da1d38a..99525a4d21a 100644
--- a/java/code/src/com/suse/manager/reactor/messaging/RegisterMinionEventMessageAction.java
+++ b/java/code/src/com/suse/manager/reactor/messaging/RegisterMinionEventMessageAction.java
@@ -441,8 +441,9 @@ public void finalizeMinionRegistration(String minionId,
                 .orElseThrow(() -> new SaltException("Missing systeminfo result. Aborting registration."));
 
             ValueMap grains = systemInfo.getGrains();
+            PublicCloudInstanceFlavor instanceFlavor = PublicCloudInstanceFlavor.UNKNOWN;
             if (cloudPaygManager.isPaygInstance() && !cloudPaygManager.hasSCCCredentials()) {
-                PublicCloudInstanceFlavor instanceFlavor = saltApi.getInstanceFlavor(minionId);
+                instanceFlavor = saltApi.getInstanceFlavor(minionId);
                 if (!RegistrationUtils.isAllowedOnPayg(systemQuery, minionId, Collections.emptySet(), grains,
                                                        instanceFlavor)) {
                     Object[] args = {minionId};
@@ -519,7 +520,7 @@ else if (!minion.getOrg().equals(org)) {
             minion.setContactMethod(getContactMethod(activationKey, isSaltSSH, minionId));
             minion.setHostname(grains.getOptionalAsString(FQDN).orElse(null));
             systemInfo.getKernelLiveVersion().ifPresent(minion::setKernelLiveVersion);
-
+            minion.setPayg(instanceFlavor.equals(PublicCloudInstanceFlavor.PAYG));
 
             String serverArch = String.format("%s-%s", osarch,
                     osfamily.equals("Debian") ? "debian-linux" : "redhat-linux");
